VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DBAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Objekt fr den Datenbankzugriff aus Businessobjekten. (DB-Access-Tier)

' Benutzt in dieser Versio DAO 3.5.

' (c) 1998 by Ralf Westphal fr BasicPro

Option Explicit


Private m_db As Database


'--- Definitionen fr die Erzeugung von GUIDs als OIDs
Private Type tGUID
    bytes(15) As Byte
End Type

Private Declare Function CoCreateGuid Lib "OLE32.dll" (guid As tGUID) As Long
Private Declare Function StringFromGUID2 Lib "OLE32.dll" (guid As tGUID, ByVal lpszString As String, ByVal lMax As Long) As Long



'------------------------------------------------------------------------


Public Sub Connect(ByVal dbPath As String)
    Set m_db = OpenDatabase(dbPath)
End Sub



'-------------------------------------------------------------------------
' Zugriffsmethoden

' Neues Kapitel unterhalb eines anderen anlegen
Public Function Add(ByVal parentOID As String, ByVal berschrift As String) As String
    Dim OID As String, sql As String
    
    OID = CreateOID
    
    sql = "insert into Inhaltsverzeichnis (oid," & IIf(parentOID = "", "", "parentOID,") & "berschrift) values("
        sql = sql & "'" & OID & "'"
        If parentOID <> "" Then sql = sql & ",'" & parentOID & "'"
        sql = sql & ",'" & PrepareStringForSQL(berschrift) & "'"
    sql = sql & ")"
    
    m_db.Execute sql
    
    Add = OID
End Function


' Laden eines Kapitels oder von Unterkapiteln
Public Function Load(ByVal OID As String, Optional ByVal loadChildren As Boolean = False) As Variant
    Dim rs As Recordset
    
    If loadChildren Then
        Dim sql As String
    
        sql = "select oid, parentOID, berschrift from Inhaltsverzeichnis where " & IIf(OID = "", "parentOID is null", "parentOID='" & OID & "'") & " order by berschrift"
        Set rs = m_db.OpenRecordset(sql, dbOpenSnapshot)
        
        If rs.EOF Then
            Load = Null
        Else
            Load = rs.GetRows(9999)
        End If
    Else
        Set rs = m_db.OpenRecordset("select oid, parentOID, berschrift from Inhaltsverzeichnis where oid='" & OID & "'", dbOpenSnapshot)
    
        Load = rs.GetRows(1)
    End If
End Function


' Kapitel mit seinen Unterkapiteln lschen
' In dieser Realisierung wird angenommen, da Unterkapitel
' durch in der Datenbank definierte referentielle Integrittsbeziehungen
' autom. gelscht werden, sobald man ein Kapitel lscht.
Public Sub Remove(ByVal OID As String)
    m_db.Execute "delete * from Inhaltsverzeichnis where oid='" & OID & "'"
End Sub


' Aktualisieren eines Kapitels
Public Sub Update(ByVal OID As String, ByVal berschrift As String)
    Dim sql As String
    
    sql = "update Inhaltsverzeichnis set "
        sql = sql & "berschrift = '" & PrepareStringForSQL(berschrift) & "'"
    sql = sql & " where oid='" & OID & "'"
    
    m_db.Execute sql
End Sub



'------------------------------------------------------------
' Erzeugen einer eindeutigen Objekt-Identifikation (OID). Windows GUIDs sind
' per Definition eindeutig!

Private Function CreateOID() As String
    Dim guid As tGUID, s$, n%
    
    s = Space(100)
    
    CoCreateGuid guid
    n = StringFromGUID2(guid, s, Len(s))
    
    CreateOID = Left$(StrConv(s, vbFromUnicode), n - 1)
End Function



'--------------------------------------------------------------------
' Alle "'" in einem String zu "''" machen. Dann kann der String
' in einem SQL-Statement in "'" eingeschlossen werden.

Private Function PrepareStringForSQL(ByVal s$) As String
    Dim i%
    
    i = -1
    Do
        i = InStr(i + 2, s, "'"): If i = 0 Then Exit Do
        
        s = Left$(s, i) & "'" & Mid$(s, i + 1)
    Loop
    
    PrepareStringForSQL = s
End Function
